#!/usr/bin/env python3
"""
   utils.database.from_api.py file for the c3 buttons.
"""


###
### DEPENDENCIES
###
import sys
from gpiozero import Button
from datetime import datetime

### LOCAL
try:
    from .box_pin import BoxPin
except ImportError as e:
    print("Unable to import 'BoxPin' from 'utils.boxes.box_pin.py' file at 'utils.boxes.box_button.py' file")
    sys.exit(1)


class BoxButton(BoxPin):
    """
        TODO: Documentation
    """

    def __init__(self, configuration: dict, box_name: str, database: object, box_led: str = None) -> None:
        """
            TODO: Documentation
        """

        ### Init super
        super().__init__(name=__name__, configuration=configuration, box_name=box_name)

        self.logger.debug(f"__init__ - box_name: '{box_name}'")

        self.box_led = box_led

        self.database = database

        self.set_pin_usage()

    def set_pin_usage(self):
        self.logger.debug(f"set_pin_usage - box_name: '{self.box_name}'")

        self.button_press_count = 0
        try:
            self.bounce_time = float(self.configuration.box_button_bounce_time)

        except Exception as e:
            print(f"\n\n Error setting the bounce_time from button with exception: {e}")
            sys.exit(1)
        
        self.button = Button(self.pin_button, bounce_time=self.bounce_time)

    def update_db_from_activated(self):
        self.logger.debug(f"update_db_from_activated - box_name '{self.box_name}' | pin_button: '{self.pin_button}'")

        self.database.add_button_box_usage(box_name=self.box_name)

    def activated(self):
        self.logger.debug(f"activated - box_name '{self.box_name}' | pin_button: '{self.pin_button}' | count: '{self.button_press_count}'")
        self.button_press_count += 1

        ### Update DB
        self.database.db.add_button_box_usage(box_name=self.box_name)

        ### Set LED activation
        if self.box_led:
            self.box_led.activated()
